<?php
	// ======================================== \
	// Package: Mihalism Multi Host
	// Version: 3.1.2
	// Copyright (c) 2007, 2008 Mihalism, Inc.
	// License: http://www.gnu.org/licenses/old-licenses/gpl-3.0.txt GNU Public License
	// ======================================== /
	
	if(!defined('IN_MMH')){
		exit("Hacking attempt");
	}
	//+======================================================+
	function get_url($base = true, $www = true, $query = true){
		$URL  = (($_SERVER['HTTPS'] != '') ? "https://" : "http://");
		$URL .= (($www == true && !preg_match("/^www\./", $_SERVER['HTTP_HOST'])) ? 'www.'.$_SERVER['HTTP_HOST'] : $_SERVER['HTTP_HOST']);
		$URL .= ((pathinfo($_SERVER['PHP_SELF'], PATHINFO_DIRNAME) != '/') ? pathinfo($_SERVER['PHP_SELF'], PATHINFO_DIRNAME).'/' : pathinfo($_SERVER['PHP_SELF'], PATHINFO_DIRNAME)); 
		$URL .= (($base == true) ? pathinfo($_SERVER['PHP_SELF'], PATHINFO_BASENAME) : "");
		$URL .= (($query == true && $_SERVER['QUERY_STRING'] != '') ? "?".$_SERVER['QUERY_STRING'] : ""); 
		return $URL;
	}
	//+======================================================+
	function convert_numbers($word){
		return strrev((string)preg_replace('/(\d{3})(?=\d)(?!\d*\.)/', '$1,', strrev($word)));
	}
	//+======================================================+
	function convert_size($size = 0){
		$i   = 0;
		$iec = array("Bytes (B)", "Kilobyte (KB)", "Megabyte (MB)", "Gigabyte (GB)");
		while(($size / 1024) > 1){
			$size = $size / 1024;
			$i++;
		}
		return substr($size, 0, strpos($size,'.') + 4).' '.$iec[$i];
	}
	//+======================================================+
	function random_string($max = 20){
		$chars = explode(" ", 'a b c d e f g h i j k l m n o p q r s t u v w x y z 0 1 2 3 4 5 6 7 8 9');
		for($i = 0; $i < $max; $i++){
			$rand_key = array_rand($chars);
			$string  .= $chars[$rand_key];
		}
		return str_shuffle($string);
	}
	//+======================================================+
	function valid_email($email){
		return ((preg_match("/[a-zA-Z]+([._][a-zA-Z]+)*@[^ ]+\.[a-zA-Z]/", preg_quote($email))) ? true : false);
	}
	//+======================================================+
	function thumbnail_name($file){
		return preg_replace("/\.".file_type($file)."/", "_thumb.".file_type($file), $file);
	}
	//+======================================================+
	function message($msg, $is_error = true){
		global $CONFIG;
		if($is_error == true){
			echo "<div class='message'><strong class='warning_title'>General Error!</strong><br><br>".$msg."<br><br><a href='contact.php?act=contact_us'>Contact us for support</a></div>";
		}else{
			echo "<div class='message'>".$msg."</div>";
		}
	}
	//+======================================================+
	function is_image($file){
		return ((in_array(file_type($file), array('jpeg', 'jpg', 'gif', 'png', 'ico', 'bmp'))) ? true : false);
	}
	//+======================================================+
	function file_type($file){
		$path_chunks = explode("/", $file);
		$thefile     = $path_chunks[count($path_chunks) - 1];
		$dotpos      = strrpos($thefile, ".");
		return strtolower(substr($thefile, $dotpos + 1));
	}
	//+======================================================+
	function random_image(){
		global $DB;
		$DB->query("SELECT * FROM `".SQL_FILE_STORAGE_TABLE."` WHERE `private_status` = '0' ORDER BY RAND() LIMIT 1 ");
		if($DB->get_num_rows() >= 1){
			while($row = $DB->fetch_row()){
				header('Location: ./viewer.php?file='.$row['file_name'].'&is_random=true');
			}
		}
	}
	//+======================================================+
	function results_table(){
		global $CONFIG, $BUTTON, $path, $filename, $remove_thumb;
		if(empty($filename) || empty($path)){
			message("Unable to load results table.");
		}else{
			$extension = file_type($filename);
			$thumb     = ((!file_exists(ROOT_PATH.$CONFIG['file_path'].thumbnail_name($filename)) || $remove_thumb == true) ? $CONFIG['site_url'].'css/nothumb.jpg' : $CONFIG['site_url'].$CONFIG['file_path'].thumbnail_name($filename));
			echo "<center>";
			if(!file_exists(ROOT_PATH.$CONFIG['file_path'].thumbnail_name($filename)) && !preg_match("/links\.php/", $_SERVER['PHP_SELF']) && $extension != 'bmp' && $extension != 'ico'){
				echo '<b>Notice</b>: Failed to create thumbnail for <b>'.$filename.'</b> because of an internal error.<br><br>';
			}
			echo '<a href="viewer.php?file='.$filename.'"><img src="'.$BUTTON['go_to_image'].'" alt="Go to image" /></a></center><br><table align="center" cellpadding="5" cellspacing="0" width="100%"><tr><td with="10%">
			<a href="'.$CONFIG['site_url'].'viewer.php?file='.$filename.'"><img src="'.$thumb.'" class="galthumb" border="0" alt="'.$CONFIG['site_name'].'" /></a>
			</td><td width="90%"><table width="100%" border="0" cellspacing="0" cellpadding="0">
			<tr><td><input onClick="javascript:highlight(this);" type="text" style="width:500px" name="option" value="'.htmlspecialchars('<a href="'.$CONFIG['site_url'].'viewer.php?file='.$filename.'"><img src="'.$thumb.'" border="0" alt="'.$CONFIG['site_name'].'" /></a>').'"></td><td>Thumbnail for Websites</td></tr>
			<tr><td><input onClick="javascript:highlight(this);" type="text" style="width:500px" name="option" value="[URL='.$CONFIG['site_url'].'viewer.php?file='.$filename.'][IMG]'.$thumb.'[/IMG][/URL]"></td><td>Thumbnail for forums (1)</td></tr>
			<tr><td><input onClick="javascript:highlight(this);" type="text" style="width:500px" name="option" value="[url='.$CONFIG['site_url'].'viewer.php?file='.$filename.'][img='.$thumb.'][/url]"></td><td>Thumbnail for forums (2)</td></tr>
			<tr><td><input onClick="javascript:highlight(this);" type="text" style="width:500px" name="option" value="'.htmlspecialchars('Thanks to '.$CONFIG['site_name'].' for <a href="'.$CONFIG['site_url'].'">Free image hosting</a>').'"></td><td>Link to site</td></tr>
			<tr><td><input onClick="javascript:highlight(this);" type="text" style="width:500px" name="option" value="[URL='.$CONFIG['site_url'].'][IMG]'.$CONFIG['site_url'].$path.$filename.'[/IMG][/URL]"></td><td>Hotlink for forums (1)</td></tr>
			<tr><td><input onClick="javascript:highlight(this);" type="text" style="width:500px" name="option" value="[url='.$CONFIG['site_url'].'][img='.$CONFIG['site_url'].$path.$filename.'][/url]"></td><td>Hotlink for forums (2)</td></tr>
			<tr><td><input onClick="javascript:highlight(this);" type="text" style="width:500px" name="option" value="'.htmlspecialchars('<a href="'.$CONFIG['site_url'].'"><img src="'.$CONFIG['site_url'].$path.$filename.'" border="0" alt="'.$CONFIG['site_name'].'" /></a>').'"></td><td>Hotlink for Websites</td></tr>
			<tr><td><input onClick="javascript:highlight(this);" type="text" style="width:500px" name="option" value="'.$CONFIG['site_url'].'viewer.php?file='.$filename.'"></td><td>Display file</td></tr>
			<tr><td><input onClick="javascript:highlight(this);" type="text" style="width:500px" name="option" value="'.$CONFIG['site_url'].'download.php?file='.$filename.'"></td><td>Download file</td></tr>
			<tr><td><input onClick="javascript:highlight(this);" type="text" style="width:500px" name="option" value="'.$CONFIG['site_url'].'links.php?file='.$filename.'"></td><td>Display links</td></tr>
			<tr><td><input onClick="javascript:highlight(this);" type="text" style="width:500px" name="option" value="'.$CONFIG['site_url'].'contact.php?act=send_file&file='.$filename.'"></td><td>Mail File</td></tr>
			<tr><td><input onClick="javascript:highlight(this);" type="text" style="width:500px" name="option" value="'.$CONFIG['site_url'].$path.$filename.'"></td><td>Direct</td></tr>
			</table></td></tr></table>';
		}
	}
	//+======================================================+
	function create_thumbnail($filename){
		global $CONFIG;
		$path         = ROOT_PATH.$CONFIG['file_path'];
		$thumbnail    = thumbnail_name($filename);
		$extension    = file_type($filename);
		$remove_thumb = false;
		$img_size     = array();
		if(in_array($extension, array('png', 'gif', 'jpg', 'jpeg'))){
			if(!$img_size = getimagesize($path.$filename)){
				$remove_thumb = true;
			}
			if($extension == 'gif'){
				if(!$image = imagecreatefromgif($path.$filename)){
					$remove_thumb = true;
				}
			}elseif($extension == 'png'){
				if(!$image = imagecreatefrompng($path.$filename)){
					$remove_thumb = true;
				}
			}elseif($extension == 'jpg' || $extension == 'jpeg'){
				if(!$image = imagecreatefromjpeg($path.$filename)){
					$remove_thumb = true;
				}
			}
			$img_height = $img_size['1'];
			$img_width  = $img_size['0'];
			if($img_width > $img_height){
				$thumb_width  = $CONFIG['thumbnail_width'];
				$thumb_height = ($img_height)*($CONFIG['thumbnail_height']/$img_width);
			}elseif($img_width < $img_height) {
				$thumb_width  = ($img_width)*($CONFIG['thumbnail_width']/$img_height);
				$thumb_height = $CONFIG['thumbnail_height'];
			}elseif($img_height == $img_width) {
				$thumb_width  = $CONFIG['thumbnail_width'];
				$thumb_height = $CONFIG['thumbnail_height'];
			}
			if($remove_thumb == false){
				$thumb = imagecreatetruecolor($thumb_width, $thumb_height);
				imagecopyresampled($thumb, $image, 0, 0, 0, 0, $thumb_width, $thumb_height, $img_size[0], $img_size[1] );
				if(function_exists('imagejpeg')){
					imagejpeg($thumb, $path.$thumbnail);
					chmod($path.$thumbnail, 0777 );
					imagedestroy($thumb);
					imagedestroy($image);
				}elseif(function_exists('imagepng')){
					imagepng($thumb, $path.$thumbnail);
					chmod($path.$thumbnail, 0777 );
					imagedestroy($thumb);
					imagedestroy($image);
				}else{
					$remove_thumb = true;
				}
			}	
		}else{
			$remove_thumb = true;
		}
	}
	//+======================================================+
	function build_pagelinks($base, $total_results){
		global $DB, $CONFIG;
		$work        = array();
		$total_pages = ceil($total_results / $CONFIG['max_results']); 
		$pages       = 1;
		$dots        = ((!preg_match('/\?/', $base)) ? "?" : "&amp;");
		if(($total_results % $CONFIG['max_results']) == 0){
			$pages = ($total_results / $CONFIG['max_results']);
		}else{
			$number = ($total_results / $CONFIG['max_results']);
			$pages = ceil( $number);
		}
		$total = $pages;
		$cpage = (($CONFIG['current_page'] > 0) ? ($CONFIG['current_page']) + 1 : 1);
		if($pages > 1){
			for($i = 0; $i <= $pages - 1; ++$i ){
				$RealNo = $i+1;
				$PageNo = $i+1;
				if ($RealNo == $CONFIG['current_page']){
					$span .= "&nbsp;<b>[{$PageNo}]</b>";
				}else{
					if ($PageNo < ($cpage - 10)){
						$sdots = "&nbsp;<a href='".$base.$dots."page=1'>&laquo; First</a>&nbsp;...";
						continue;
					}
					if ($PageNo > ($cpage + 10)){
						$edots = "...&nbsp;<a href='".$base.$dots."page=".($pages)."'>Last &raquo;</a>";
						break;
					}
					$span .= "&nbsp;<a href='".$base.$dots."page={$RealNo}'>{$PageNo}</a>";
				}
			}
			return "Pages: ".$sdots.$span.'&nbsp;'.$edots;
		}else{
			return 'Pages: Viewing Only Page';
		}
	}
	//+======================================================+
	function get_rating($file){
		global $DB;
		$DB->query("SELECT * FROM `".SQL_RATINGS_TABLE."` WHERE `file_name` = '".$file."'");
		$row    = $DB->fetch_row();
		$rating = ($row['total'] / $row['votes']);
		if((($rating >= 0) || ($rating == 0)) && ($rating <= 0.50)){ 
			$rhtml = "<img src=\"css/no_rating.gif\" style=\"vertical-align:middle;\" alt=\"zero stars\" />"; 
		}elseif((($rating >= 0.50) || ($rating == 0.50)) && ($rating <= .99)){ 
			$rhtml = "<img src=\"css/half_star.gif\" style=\"vertical-align:middle;\" alt=\"half a star\" />"; 
		}elseif((($rating >= 1.00) || ($rating == 1.50)) && ($rating <= 1.49)){ 
			$rhtml = "<img src=\"css/one_star.gif\" style=\"vertical-align:middle;\" alt=\"one star\" />"; 
		}elseif((($rating >= 1.50) || ($rating == 1.50)) && ($rating <= 1.99)){ 
			$rhtml = "<img src=\"css/one_half_star.gif\" style=\"vertical-align:middle;\" alt=\"one and half stars\" />"; 
		}elseif((($rating >= 2.00) || ($rating == 2.00)) && ($rating <= 2.49)){ 
			$rhtml = "<img src=\"css/two_star.gif\" style=\"vertical-align:middle;\" alt=\"two stars\" />"; 
		}elseif((($rating >= 2.50) || ($rating == 2.50)) && ($rating <= 2.99)){ 
			$rhtml = "<img src=\"css/two_half_star.gif\" style=\"vertical-align:middle;\" alt=\"two and half stars\" />"; 
		}elseif((($rating >= 3.00) || ($rating == 3.00)) && ($rating <= 3.49)){ 
			$rhtml = "<img src=\"css/three_star.gif\" style=\"vertical-align:middle;\" alt=\"three stars\" />"; 
		}elseif((($rating >= 3.50) || ($rating == 3.50)) && ($rating <= 3.99)){ 
 			$rhtml = "<img src=\"css/three_half_star.gif\" style=\"vertical-align:middle;\" alt=\"three and half stars\" />"; 
		}elseif((($rating >= 4.00) || ($rating == 4.00)) && ($rating <= 4.49)){ 
 			$rhtml = "<img src=\"css/four_star.gif\" style=\"vertical-align:middle;\" alt=\"four stars\" />"; 
		}elseif((($rating >= 4.50) || ($rating == 4.50)) && ($rating <= 4.99)){ 
			$rhtml = "<img src=\"css/four_half_star.gif\" style=\"vertical-align:middle;\" alt=\"four and half stars\" />"; 
		}elseif($rating == 5.0){ 
			$rhtml = "<img src=\"css/five_star.gif\" style=\"vertical-align:middle;\" alt=\"five stars\" />"; 
		}else{
			$rhtml = "Unknown Rating";
		}
		return array('html' => $rhtml, 'total' =>  (($row['total'] != '') ? $row['total'] : 0), 'votes' => (($row['votes'] != '') ? $row['votes'] : 0));
	}
	//+======================================================+
?>
