<!-- BEGIN: USER REGISTRATION PAGE -->
<template id="registration_page">

<form action="users.php?act=register-d" method="post">
	<input type="hidden" name="return" value="<# RETURN_URL #>" />
    
  	<div class="table_border">
        <table cellpadding="4" cellspacing="1" border="0" style="width: 100%;">
            <tr>
                <th colspan="2">Register at <# SITE_NAME #></th>
            </tr>
            <tr>
                <td style="width: 30%;" class="tdrow1"><span>نام کاربری:</span> <br /> <div class="explain">نام کاربری می تواند شامل 3 تا 30 حرف باشد</div></td> 
                <td class="tdrow2" valign="top">
                    <input type="text" name="username" id="username_field" class="input_field" style="width: 300px;" maxlength="30" />
                    <br /><br />
                    <div id="username_check"><a href="javascript:void(0);" onclick="check_username();">برسی موجود بودن</a></div>
                </td>
            </tr>
            <tr>
                <td style="width: 30%;" class="tdrow1"><span>پسورد:</span> <br /> <div class="explain"> از انتخاب پسورد های اسان خودداری کنید ! پسورد می تواند شامل 6 تا 30 حرف باشد</a></div></td> 
                <td class="tdrow2" valign="top"><input type="password" name="password" class="input_field" style="width: 300px;" maxlength="30" /></td>
            </tr>
            <tr>
                <td style="width: 30%;" class="tdrow1"><span>پسورد (retype):</span></td> 
                <td class="tdrow2"><input type="password" name="password-c" class="input_field" style="width: 300px;" /></td>
            </tr>
            <tr>
                <td style="width: 30%;" class="tdrow1"><span>ادرس ایمیل:</span> <br /> <div class="explain"> استفاده از ایمیل های فیک و و موقت در این سرویس دهی ممنوع می باشد</div></td> 
                <td class="tdrow2" valign="top"><input type="text" class="input_field" name="email_address" style="width: 300px;" /></td>
            </tr>
            <tr>
                <td style="width: 30%;" class="tdrow1" valign="top"><span>کد امنیتی:</span></td> 
                <td class="tdrow2"><# CAPTCHA_CODE #></td>
            </tr>
            <tr>
                <td class="tdrow2" colspan="2" style="height: 35px;">
                	<div class="text_align_center">
       	            	<input type="checkbox" name="iagree" id="iagree" value="1" /> <label for="iagree">شما با کلیک بر روی دکمه پایان در واقع <a href="info.php?act=privacy_policy">قوانین</a> و <a href="info.php?act=rules">چگونگی سرویس دهی</a> را قبول کرده اید.</label>
                	</div>
                </td>
            </tr>
            <tr>
                <td colspan="2" class="table_footer"><input type="submit" value="پایان" class="button1" /></td>
            </tr>
        </table>
  	</div>
</form>

</template>
<!-- END: USER REGISTRATION PAGE -->

<!-- BEGIN: USER REGISTRATION HARD LIMIT EMAIL -->
<template id="user_registration_hard_limit">

<# SITE_NAME #> مدیریت,
<br /><br />
هر کاربر با یک ای پی فقط پنج بار می تواند عضو شود .<br />
ادرس ای پی شما: <a href="http://whois.domaintools.com/<# IP_ADDRESS #>"><# IP_ADDRESS #></a>.
<br /><br />
To take action, log in to the Admin Control Panel at:
<br /><br />
<# BASE_URL #>admin.php

</template>
<!-- END: USER REGISTRATION HARD LIMIT EMAIL -->

<!-- BEGIN: USER LOGIN LIGHTBOX -->
<template id="login_lightbox">

<form action="users.php?act=login-d" method="post">
	<input type="hidden" name="return" value="<# RETURN_URL #>" />
    
	<table cellpadding="4" cellspacing="1" border="0" style="width: 100%; background: #ebf1f5;">
		<tr>
            <th colspan="2">ورود</th>
        </tr>
        <tr>
            <td colspan="2">&nbsp;</td>
        </tr>
        <tr>
            <td class="text_align_right" style="width: 45%;"><span>نام کاربری</span>:&nbsp;</td> 
            <td><input type="text" name="username" class="input_field" style="width: 200px;" /></td>
        </tr>
        <tr>
         	<td class="text_align_right" style="width: 45%;"><span>پسورد</span>:&nbsp;</td>
            <td><input type="password" name="password" class="input_field" style="width: 200px;" /></td>
        </tr>
        <tr>
            <td class="text_align_center" style="height: 45px;" colspan="2">
            	<input type="submit" value="ورود" class="button1" />
           	</td>
        </tr>
        <tr>
            <td class="text_align_center" style="font-size: 10px;" colspan="2">
                ( <a href="javascript:void(0);" onclick="toggle_lightbox('no_url', '<# LIGHTBOX_ID #>'); toggle_lightbox('users.php?act=lost_password', 'lost_password_lightbox');">بازیابی پسورد</a> | 
                <a href="users.php?act=register&amp;return=<# RETURN_URL #>">عضویت</a> )
            </td>
        </tr>
        <tr>
            <td colspan="2">&nbsp;</td>
        </tr>
        <tr>
            <td class="table_footer" colspan="2"><a onclick="toggle_lightbox('no_url', '<# LIGHTBOX_ID #>');">بستن پنجره</a></td>
        </tr>
    </table>
</form>

</template>
<!-- END: USER LOGIN LIGHTBOX -->

<!-- BEGIN: FORGOTTEN PASSWORD LIGHTBOX -->
<template id="forgotten_password_lightbox">

<form action="users.php?act=lost_password-d" method="post">
	<table cellpadding="4" cellspacing="1" border="0" style="width: 100%; background: #ebf1f5;">
		<tr>
			<th colspan="2">بازیابی پسورد</th>
		</tr>
		<tr>
			<td colspan="2">&nbsp;</td>
		</tr>
		<tr>
			<td class="text_align_right" style="width: 45%;"><span>نام کاربری</span>:&nbsp;</td> 
			<td><input type="text" name="username" class="input_field" style="width: 200px;" /></td>
		</tr>
		<tr>
			<td class="text_align_right" style="width: 45%;"><span>ادرس ایمیل</span>:&nbsp;</td> 
			<td><input type="text" name="email_address" class="input_field" style="width: 200px;" /></td>
		</tr>
		<tr>
			<td colspan="2" class="text_align_center" style="height: 45px;">
            	<input type="submit" value="ارسال پسورد" class="button1" />
          </td>
		</tr>
		<tr>
			<td colspan="2" class="table_footer"><a onclick="toggle_lightbox('no_url', '<# LIGHTBOX_ID #>');">بستن پنجره</a></td>
		</tr>
	</table>
</form>

</template>
<!-- END: FORGOTTEN PASSWORD LIGHTBOX -->

<!-- BEGIN: FORGOTTEN PASSWORD EMAIL -->
<template id="forgotten_password_email">

سلام <# USERNAME #>,
<br /><br />
شما درخواست بازیابی پسورد را داده اید<br />
در صورتی که اینجنین نیست این ایمیل را نادیده بگیرید<br />
در صورت پیگیری با مدیریت در ارتباط باشید <a href="<# BASE_URL #>contact.php?act=contact_us">تماس با مدیریت</a>.
<br /><br />
برای فعال کردن پسورد بر روی لینک زیر کلیک کنید
<br /><br />
<a href="<# BASE_URL #>users.php?act=lost_password-a&id=<# AUTH_KEY #>">برای فعال شدن کلیک کنید  </a>
<br /><br />
اطلاعات جدید شما :
<br /><br />
<strong>نام کاربری:</strong> <# USERNAME #><br />
<strong>پسورد:</strong> <# NEW_PASSWORD #>
<br /><br />
<em>لحظه هایتان ارام</em>
<br /><br />
----<br />
<# SITE_NAME #> پشتیبانی<br />
<# ADMIN_EMAIL #>

</template>
<!-- END: FORGOTTEN PASSWORD EMAIL -->

<!-- BEGIN: USER LIST PAGE -->
<template id="user_list_page">
<div class="container cont inline">
<# PAGINATION_LINKS #>
<br /><br />

<div class="table_border">
	<table cellpadding="4" cellspacing="1" border="0" style="width: 100%;" id="usersgallaryforA">
		<tr class="somtup">
			<th>نام کاربری</th>
			<th>تاریخ عضویت</th>
			<th>وضعیت گالری</th>
			<th>تعداد اپلود</th>
			<th>&nbsp;</th>
		</tr>
        
		<while id="user_list_whileloop">
			<tr class="IlmHt">
				<td class="<# TDCLASS #>"><a href="users.php?act=gallery&amp;gal=<# USER_ID #>"><# USERNAME #></a></td>
				<td class="<# TDCLASS #>"><# TIME_JOINED #></td>
				<td class="<# TDCLASS #>"><# GALLERY_STATUS #></td>
				<td class="<# TDCLASS #>"><# TOTAL_UPLOADS #></td>
				<td class="<# TDCLASS #>"><a href="users.php?act=gallery&amp;gal=<# USER_ID #>">نمایش گالری</a></td>
			</tr>
		</endwhile>
        
		<tr>
			<td colspan="5" class="table_footer">&nbsp;</td>
		</tr>
	</table>
</div>
</div>

</template>
<!-- END: USER LIST PAGE -->

<!-- BEGIN: MY GALLERY PAGE -->
<template id="my_gallery_page">
<div class="container cont inline">
<div class="GLbOl">
<div class="align_left_mfix">
    <ul class="jd_menu">
        <if="$mmhclass->info->user_owned_gallery == true">
     		<li><span onclick="gallery_action('delete');" title="Delete Selected" class="button1">حذف عکس ها</span></li>
            <li><span onclick="gallery_action('move');" title="Move Selected" class="button1">انتقال عکس ها</span></li>
      		<li><span onclick="gallery_action('select');" title="Select/Deselect All" class="button1">انتخاب همه</span></li>
        </endif>
        
        <if="$mmhclass->funcs->is_null($mmhclass->input->get_vars['search']) == true">

        </endif>
    </ul>
</div>

<# PAGINATION_LINKS #>

<if="$mmhclass->templ->templ_globals['empty_gallery'] == true">
	<# EMPTY_GALLERY #>
<else>
    <div class="table_border">
        <table cellpadding="4" cellspacing="1" border="0" style="width: 100%;">
            <tr>
	            <th colspan="4" class="titlegl">
            		<if="$mmhclass->funcs->is_null($mmhclass->input->get_vars['search']) == true">
               			<# GALLERY_OWNER #>  گالری
      				<else>
                    	Searching for "<# IMAGE_SEARCH #>"
                	</endif>
                </th>
            </tr>
            <tr>
                <# GALLERY_HTML #>
            </tr>
        </table>
    </div>
    
    <div class="pagination_footer">
        <# PAGINATION_LINKS #>
    </div>
</endif>
</div>
</div>
</template>
<!-- END: MY GALLERY PAGE -->

<!-- BEGIN: MOVE FILES LIGHTBOX -->
<template id="move_files_lightbox">

<table cellpadding="4" cellspacing="1" border="0" style="width: 100%;">
	<tr>
		<th>Move Images</th>
	</tr>
	<tr>
		<td class="tdrow1 text_align_center">
			<br />
			<form action="users.php?act=move_files-d" method="post">
				<p>
					<b>Move To</b>:
					<br /><br />
                    
					<select name="move_to" style="width: 200px;">
						<option value="root">Root Album</option>
                        
						<while id="album_options_whileloop">
							<option value="<# ALBUM_ID #>">&bull; <# ALBUM_NAME #></option>
						</endwhile>
					</select>
					<br /><br />
                    
					<input type="hidden" value="<# FILES2MOVE #>" name="files" />
					<input type="hidden" value="<# RETURN_URL #>" name="return" />
                    
					<input type="submit" value="جابه جایی" class="button1" />
					<input type="button" value="لغو" class="button1" onclick="toggle_lightbox('no_url', '<# LIGHTBOX_ID #>');" />
				</p>
			</form>
			<br /><br />
		</td>
	</tr>
	<tr>
		<td class="table_footer"><a onclick="toggle_lightbox('no_url', '<# LIGHTBOX_ID #>');">Close Window</a></td>
	</tr>
</table>

</template>
<!-- END: MOVE FILES LIGHTBOX -->

<!-- BEGIN: DELETE FILES LIGHTBOX -->
<template id="delete_files_lightbox">

<table cellpadding="4" cellspacing="1" border="0" style="width: 100%;">
	<tr>
		<th>Confirm Image Deletion</th>
	</tr>
	<tr>
		<td class="tdrow1 text_align_center">
			<br />
			<form action="users.php?act=delete_files-d" method="post">
				<p>
					Are you sure you wish to carry out this operation? 
					<br /><br />
					If you select "Yes" there is no undo.
					<br /><br />
                    
					<input type="hidden" value="<# RETURN_URL #>" name="return" />
					<input type="hidden" value="<# FILES2DELETE #>" name="files" />
                    
					<input type="submit" value="Yes" class="button1" />
					<input type="button" value="No" class="button1" onclick="toggle_lightbox('no_url', '<# LIGHTBOX_ID #>');" />
				</p>
			</form>
			<br /><br />
		</td>
	</tr>
	<tr>
		<td class="table_footer"><a onclick="toggle_lightbox('no_url', '<# LIGHTBOX_ID #>');">Close Window</a></td>
	</tr>
</table>

</template>
<!-- END: DELETE FILES LIGHTBOX -->

<!-- BEGIN: NEW ALBUM LIGHTBOX -->
<template id="new_album_lightbox">

<table cellpadding="4" cellspacing="1" border="0" style="width: 100%;">
	<tr>
		<th>New Album</th>
	</tr>
	<tr>
		<td class="tdrow1 text_align_center">
			<br />
			<form action="users.php?act=albums-c-d" method="post">
				<p>
					<b>Album Title</b>:
					<br /><br />
                    
					<input type="text" name="album_title" maxlength="50" class="input_field" style="width: 250px;" />
					<br /><br />
                    
					<input type="hidden" value="<# RETURN_URL #>" name="return" />
                    
					<input type="submit" value="Create Album" class="button1" />
					<input type="button" value="Cancel" class="button1" onclick="toggle_lightbox('no_url', '<# LIGHTBOX_ID #>');" />
				</p>
			</form>
			<br /><br />
		</td>
	</tr>
	<tr>
		<td class="table_footer"><a onclick="toggle_lightbox('no_url', '<# LIGHTBOX_ID #>');">Close Window</a></td>
	</tr>
</table>

</template>
<!-- END: NEW ALBUM LIGHTBOX -->

<!-- BEGIN: RENAME ALBUM LIGHTBOX -->
<template id="rename_album_lightbox">

<table cellpadding="4" cellspacing="1" border="0" style="width: 100%;">
	<tr>
		<th>Rename Album</th>
	</tr>
	<tr>
		<td class="tdrow1 text_align_center">
			<br />
			<form action="users.php?act=albums-r-d" method="post">
				<p>
					<b>New Album Title</b>:
					<br /><br />
                    
					<input type="text" name="album_title" maxlength="50" class="input_field" style="width: 250px;" value="<# OLD_TITLE #>" onclick="$(this).val('');" />
					<br /><br />
                    
					<input type="hidden" value="<# ALBUM_ID #>" name="album" />
					<input type="hidden" value="<# RETURN_URL #>" name="return" />
                    
					<input type="submit" value="Rename Album" class="button1" />
					<input type="button" value="Cancel" class="button1" onclick="toggle_lightbox('no_url', '<# LIGHTBOX_ID #>');" />
				</p>
	    	</form>
			<br /><br />
		</td>
	</tr>
	<tr>
		<td class="table_footer"><a onclick="toggle_lightbox('no_url', '<# LIGHTBOX_ID #>');">Close Window</a></td>
	</tr>
</table>

</template>
<!-- END: RENAME ALBUM LIGHTBOX -->

<!-- BEGIN: DELETE ALBUM LIGHTBOX -->
<template id="delete_album_lightbox">

<table cellpadding="4" cellspacing="1" border="0" style="width: 100%;">
	<tr>
		<th>Confirm Album Deletion</th>
	</tr>
	<tr>
		<td class="tdrow1 text_align_center">
			<br />
			<form action="users.php?act=albums-d-d" method="post">
				<p>
					Are you sure you wish to carry out this operation? 
					<br /><br />
					If you select "Yes" there is no undo.
					<br /><br />
                    
					<input type="hidden" value="<# ALBUM2DELETE #>" name="album" />
                    
					<input type="submit" value="Yes" class="button1" />
					<input type="button" value="No" class="button1" onclick="toggle_lightbox('no_url', '<# LIGHTBOX_ID #>');" />
                    <br /><br />
                    
					<div style="font-size: 10px; font-style: italic;">
                    	<strong>Note:</strong> Images within this album will be moved to the root album, not deleted.
                    </span>
				</p>
			</form>
			<br /><br />
		</td>
	</tr>
	<tr>
		<td class="table_footer"><a onclick="toggle_lightbox('no_url', '<# LIGHTBOX_ID #>');">بستن پنچره</a></td>
		<td class="table_footer"><a onclick="toggle_lightbox('no_url', '<# LIGHTBOX_ID #>');">بستن پنچره</a></td>
	</tr>
</table>

</template>
<!-- END: DELETE ALBUM LIGHTBOX -->

<!-- BEGIN: USER SETTINGS PAGE -->
<template id="user_settings_page">
<div class="container cont inline">
<form action="users.php?act=settings-s" method="post">
	<div class="table_border">
		<table cellpadding="4" cellspacing="1" border="0" style="width: 100%;" id="settings_panelSv">
			<tr style="float:none !important;   display: table-row !important;">
				<th colspan="2" class="titlegl" style="position: relative;top: -10px;">تنظیمات کاربری</th>
			</tr>
			<tbody id="fulvstnh">
			<tr>
				<td class="tdrow1" style="width: 38%;"><span>ایدی کاربر</span>:</td>
				<td class="tdrow2"><# USER_ID #></td>
			</tr>
			<tr>
				<td class="tdrow1" style="width: 38%;"><span>نام کاربری</span>:</td>
				<td class="tdrow2"><# USERNAME #></td>
			</tr>
			<tr>
				<td class="tdrow1" style="width: 38%;" valign="top"><span>پسورد</span>: <br /> <div class="explain">پسورد می تواند از یک تا 30 حرف باشد</div></td>
				<td class="tdrow2" valign="top"><input type="password" style="width: 300px;" class="input_field" name="password" maxlength="30" value="*************" /></td>
			</tr>
			<tr>
				<td class="tdrow1" style="width: 38%;"><span>ادرس ای پی</span>:</td>
				<td class="tdrow2" style="  direction: ltr;"><p title="<# IP_HOSTNAME #>" class="help"><# IP_ADDRESS #></p> ( <a href="http://whois.domaintools.com/<# IP_ADDRESS #>" target="_blank">Whois</a> | <a href="http://just-ping.com/index.php?vh=<# IP_ADDRESS #>" target="_blank">Ping</a> )</td>
			</tr>
			<tr>
				<td class="tdrow1" style="width: 38%;"><span>ادرس ایمیل</span>: <br /> <div class="explain">امکان استفاده از ایمیل های تقلبی و موقت نیست</div></td>
				<td class="tdrow2" valign="top"><input type="text" style="width: 300px;" name="email_address" class="input_field" value="<# EMAIL_ADDRESS #>" /></td>
			</tr>
			<tr>
				<td class="tdrow1" style="width: 38%"><span>گالری عمومی</span>: <br /> <div class="explain"> در صورت فعال کردن فقط شما و مدیریت سایت می توانید از گالری بازدید کنید</div></td>
				<td class="tdrow2" valign="top"><input type="radio" name="private_gallery" id="checkyesv" value="1" <# PRIVATE_GALLERY_YES #> /> <label for="checkyesv">بله</label> <input type="radio" name="private_gallery" value="0" <# PRIVATE_GALLERY_NO #> id="Nochecksv" /> <label for="Nochecksv">خیر</label></td>
			</tr>
			<tr>
				<td class="tdrow1" style="width: 38%;"><span>تاریخ عضویت</span>:</td>
				<td class="tdrow2"><# TIME_JOINED #></td>
			</tr>
			<tr>
				<td class="tdrow1" style="width: 38%;"><span>گروه کاربر</span>:</td>
				<td class="tdrow2"><# USER_GROUP #></td>
			</tr></tbody>
			<tr>
				<td class="table_footer" colspan="2"><input type="submit" value="ذخیره تنظیمات" class="ratethis" /></td>
			</tr>
		</table>
	</div>
</form> 
</div>
</template>
<!-- END: USER SETTINGS PAGE -->